/*--------------------------------------------------------------------*/
/*       L o g . h p p                                                */
/*                                                                    */
/*       Definitions file for class "log"                             */
/*--------------------------------------------------------------------*/
/*       Copyright (c) 1999 by Fyodor Ustinov                         */
/*                          FIDONet 2:5020/79                         */
/*                                                                    */
/*       All rights reserved.                                         */
/*--------------------------------------------------------------------*/
#ifndef _LOG_HPP_
#define _LOG_HPP_

#include <stdio.h>
#include "ufmtypes.h"

#define EOL '\n'

class LogStream {
   FILE *fh;
   uint _LogLevel;
   uint cLogLevel;
   int  NewLine;
private:
   void ShowLine(const char *format, ...)
#ifdef __GNUC__
   __attribute__ ((format (printf, 2, 3)))
#endif
   ;

public:
    LogStream ();
    ~LogStream ();
    int Open(char *FName);
    int Opened(void) { return (fh != NULL); };
    int Close(void);
    void LogLevel(uint);
    LogStream &Level(uint);
    LogStream &operator << (const char *p);
    LogStream &operator << (char p);
    LogStream & operator << (signed int i);
    LogStream & operator << (unsigned int);
    LogStream & operator << (dword i);
    LogStream & operator << (sdword i);
};

char *Date(void);

#endif

