#ifndef _OUTBOUND_HPP_
#define _OUTBOUND_HPP_
#include <stdio.h>
#include "fidoaddr.h"

int SetAddToNullPkt(void);
int SetOutbound(void);
int SetTrafficLog(void);
int SetTempMail(void);
int SetKillRoutedMessages(void);

typedef enum { DIRECT, CRASH, HOLD, NORMAL, ATTACH } PKTMode;

typedef enum { BSY, NULLPKT, PKTERROR, ATTERROR, PKTOK, NEWPKT, BADPKT } PKTrc;

class PKT {
public:
   char *BsyFile;
   FA Addr;
   PKTMode Mode;
   FILE *fh;

   PKT();
   ~PKT();
   int Set(FA &f);
   PKTrc Open(PKTMode m);
   PKTrc AddMsg(cMSG &m, PKTMode mod);
   PKTrc Poll(PKTMode mod);
   int Clean(void);
   int Bsy(void);
   void DelBsy(void);
};

void LogTraffic(cMSG &m, FA &ToAddr);
int AddToLo(char *Txt);
int DelFromLo(char *Txt);
int InitOutbound(void);
int DoRepack(void);

#endif

