#ifndef _PARSETPL_HPP_
#define _PARSETPL_HPP_
#include "fidoaddr.h"
#include "msg.hpp"
#include "cfg.hpp"

class ScanDir;

#define TPLADD   4096

class Template {
   char *TplName;
   FILE *fh;
   char *LastTplLine;
   char *CurrLinePos;
   uint MaxBodySize;
   char *FName;
public:
   cMSG  *From;
   cMSG  *To;
   ScanDir *sd;
   char *RoutedVia;
   char *Body;
   uint BodySize;
   Template();
   ~Template();
   int AddTok(char *T);
   void AddChar(char c);
   void AddStr(char *c);
   int GetOneLine (void);
   int ParseOneLine (void);
   int Parse(void);
   void SetMsg(cMSG &F, cMSG &T) { From = &F; To = &T;};
   void SetMsg(cMSG &F) { From = &F; To = &F;};
   int Set(char *Name);
   int Save(char *name,int Mode);
   int Save(cMSG &m);
   void Normalise(void);
   void Clean(void);
};

#endif

