// --------------------------------------------------------------------
//       A g e . c p p
//                                                                     
//        Fido messages tracker                            
//        Age support
// --------------------------------------------------------------------
//        Copyright (c) 1998,99 by Fyodor Ustinov                         
//                              FIDONet 2:5020/79                      
//                                                                     
//        All rights reserved.                                         
// --------------------------------------------------------------------
#ifndef UNIX
#include <io.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "constant.hpp"
#include "help.hpp"
#include "utils.hpp"
#include "vars.hpp"
#include "cfg.hpp"
#include "fidoaddr.h"
#include "scandir.hpp"
#include "ufmtypes.h"
#include "a_list.hpp"

// --------------------------------------------------------------------

class tAka {
public:
   FA _Addr;
   FA _Mask;
   tAka() { _Addr.Clean(); _Mask.Clean(); };
   ~tAka() { return; };
};

IndBiList<tAka> Aka;
// --------------------------------------------------------------------

void AddAka(FA &Addr, FA &Mask) {
tAka *a;

   a = new tAka;
   a->_Addr = Addr;
   a->_Mask = Mask;
   Aka.AddToEnd(a);
}

FA &GetMyAka(FA const &Addr) {
IndBiList<tAka>::ElemPtr tmt;

   for (tmt = Aka.GetFirst(); tmt != NULL; tmt++) {
      if (tmt->_Mask == Addr) {
         return tmt->_Addr;
      }
   }   
   return MyAddr;
}

int IsMyAka(FA const &Addr) {
IndBiList<tAka>::ElemPtr tmt;

   for (tmt = Aka.GetFirst(); tmt != NULL; tmt++) { 
      if (tmt->_Addr == Addr) {
         return TRUE;
      }
   }   
   return (MyAddr == Addr);
}

int SetAka(void) {
FA f,m;
   f = GetFA();
   if (!f.Valid()) {
      CfgError("Invalid our addres.");
      return (-1);
   }
   if (f.Masked()) {
      CfgError("Our addres should do not be a mask.");
      return (-1);
   }

   m = GetFA();
   if (!m.Valid()) {
      CfgError("Invalid mask.");
      return (-1);
   }
   AddAka(f,m);
   return(0);
}

void DestroyAka(void) {
   Aka.Clear();
}

// ---------------------------- END --------------------------------------
